Codeforces Round #393 (Div. 2) C Pavel and barbecue(思维)

C. Pavel and barbecue

time limit per test:2 seconds

memory limit per test:256 megabytes

input:standard input

output:standard output

Pavel cooks barbecue. There are n skewers, they lay on a brazier in a row, each on one of n positions. Pavel wants each skewer to be cooked some time in every of n positions in two directions: in the one it was directed originally and in the reversed direction.

Pavel has a plan: a permutation p and a sequence b1, b2, …, bn, consisting of zeros and ones. Each second Pavel move skewer on position i to position pi, and if bi equals 1 then he reverses it. So he hope that every skewer will visit every position in both directions.

Unfortunately, not every pair of permutation p and sequence b suits Pavel. What is the minimum total number of elements in the given permutation p and the given sequence b he needs to change so that every skewer will visit each of 2n placements? Note that after changing the permutation should remain a permutation as well.

There is no problem for Pavel, if some skewer visits some of the placements several times before he ends to cook. In other words, a permutation p and a sequence b suit him if there is an integer k (k ≥ 2n), so that after k seconds each skewer visits each of the 2n placements.

It can be shown that some suitable pair of permutation p and sequence b exists for any n.

Input

The first line contain the integer n (1 ≤ n ≤ 2·105) — the number of skewers.

The second line contains a sequence of integers p1, p2, …, pn (1 ≤ pi ≤ n) — the permutation, according to which Pavel wants to move the skewers.

The third line contains a sequence b1, b2, …, bn consisting of zeros and ones, according to which Pavel wants to reverse the skewers.

Output

Print single integer — the minimum total number of elements in the given permutation p and the given sequence b he needs to change so that every skewer will visit each of 2n placements.

Examples

Input
4
4 3 2 1
0 1 1 1

Output
2

Input
3
2 3 1
0 0 0

Output
1

Note

In the first example Pavel can change the permutation to 4, 3, 1, 2.

In the second example Pavel can change any element of b to 1.
题意:有n个炉子。初始有n个正面朝上的串。每次把i位置的串放到pi的炉子上,如果bi为1,还需要翻个面。问你最少的改动方法使得你的串可以经过所有的炉子并且最后反面朝上。
题解:因为要经过所有的炉子,所以翻面的次数为sum(bi),如果和为偶数,我们把一个“1”变成”0“。再判断炉子可以形成多少个环。
代码:

#include <bits/stdc++.h>
#define ll long long
using namespace std;
int n;
int p[200100];
int b[200100];
int vis[200200];
int dfs(int x)
{
    vis[x]=1;
    if(!vis[p[x]]) dfs(p[x]);
}
int main()
{
    scanf("%d",&n);
    for(int i=1;i<=n;i++) scanf("%d",&p[i]);
    int cnt=0;
    for(int i=1;i<=n;i++)
    {
        scanf("%d",&b[i]);
        if(b[i]&1) cnt++;
    }
    int ans=0;
    if(cnt%2==0) ans++;
    cnt=0;
    for(int i=1;i<=n;i++)
    {
        if(!vis[i])
        {
            cnt++;
            dfs(i);
        }
    }
    if(cnt==1) cnt=0;
    printf("%d\n",ans+cnt);
}
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值